Index: kernel/arch/ppc32/src/mm/tlb.c
===================================================================
--- kernel/arch/ppc32/src/mm/tlb.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/src/mm/tlb.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -33,337 +33,23 @@
  */
 
-#include <mm/tlb.h>
 #include <arch/mm/tlb.h>
-#include <arch/interrupt.h>
 #include <interrupt.h>
-#include <mm/as.h>
-#include <mm/page.h>
-#include <arch.h>
-#include <print.h>
-#include <macros.h>
-#include <symtab.h>
+#include <typedefs.h>
 
-static unsigned int seed = 10;
-static unsigned int seed_real
-    __attribute__ ((section("K_UNMAPPED_DATA_START"))) = 42;
-
-/** Try to find PTE for faulting address
- *
- * @param as       Address space.
- * @param lock     Lock/unlock the address space.
- * @param badvaddr Faulting virtual address.
- * @param access   Access mode that caused the fault.
- * @param istate   Pointer to interrupted state.
- * @param pfrc     Pointer to variable where as_page_fault() return code
- *                 will be stored.
- *
- * @return PTE on success, NULL otherwise.
- *
- */
-static pte_t *find_mapping_and_check(as_t *as, uintptr_t badvaddr, int access,
-    istate_t *istate, int *pfrc)
+void tlb_refill(unsigned int n, istate_t *istate)
 {
-	ASSERT(mutex_locked(&as->lock));
-
-	/*
-	 * Check if the mapping exists in page tables.
-	 */
-	pte_t *pte = page_mapping_find(as, badvaddr);
-	if ((pte) && (pte->present)) {
-		/*
-		 * Mapping found in page tables.
-		 * Immediately succeed.
-		 */
-		return pte;
-	} else {
-		/*
-		 * Mapping not found in page tables.
-		 * Resort to higher-level page fault handler.
-		 */
-		page_table_unlock(as, true);
-		
-		int rc = as_page_fault(badvaddr, access, istate);
-		switch (rc) {
-		case AS_PF_OK:
-			/*
-			 * The higher-level page fault handler succeeded,
-			 * The mapping ought to be in place.
-			 */
-			page_table_lock(as, true);
-			pte = page_mapping_find(as, badvaddr);
-			ASSERT((pte) && (pte->present));
-			*pfrc = 0;
-			return pte;
-		case AS_PF_DEFER:
-			page_table_lock(as, true);
-			*pfrc = rc;
-			return NULL;
-		case AS_PF_FAULT:
-			page_table_lock(as, true);
-			*pfrc = rc;
-			return NULL;
-		default:
-			panic("Unexpected rc (%d).", rc);
-		}
-	}
-}
-
-static void pht_refill_fail(uintptr_t badvaddr, istate_t *istate)
-{
-	fault_if_from_uspace(istate, "PHT Refill Exception on %p.",
-	    (void *) badvaddr);
-	panic_memtrap(istate, PF_ACCESS_UNKNOWN, badvaddr,
-	    "PHT Refill Exception.");
-}
-
-static void pht_insert(const uintptr_t vaddr, const pte_t *pte)
-{
-	uint32_t page = (vaddr >> 12) & 0xffff;
-	uint32_t api = (vaddr >> 22) & 0x3f;
+	uint32_t tlbmiss;
+	ptehi_t ptehi;
+	ptelo_t ptelo;
 	
-	uint32_t vsid = sr_get(vaddr);
-	uint32_t sdr1 = sdr1_get();
+	asm volatile (
+		"mfspr %[tlbmiss], 980\n"
+		"mfspr %[ptehi], 981\n"
+		"mfspr %[ptelo], 982\n"
+		: [tlbmiss] "=r" (tlbmiss),
+		  [ptehi] "=r" (ptehi),
+		  [ptelo] "=r" (ptelo)
+	);
 	
-	// FIXME: compute size of PHT exactly
-	phte_t *phte = (phte_t *) PA2KA(sdr1 & 0xffff0000);
-	
-	/* Primary hash (xor) */
-	uint32_t h = 0;
-	uint32_t hash = vsid ^ page;
-	uint32_t base = (hash & 0x3ff) << 3;
-	uint32_t i;
-	bool found = false;
-	
-	/* Find colliding PTE in PTEG */
-	for (i = 0; i < 8; i++) {
-		if ((phte[base + i].v)
-		    && (phte[base + i].vsid == vsid)
-		    && (phte[base + i].api == api)
-		    && (phte[base + i].h == 0)) {
-			found = true;
-			break;
-		}
-	}
-	
-	if (!found) {
-		/* Find unused PTE in PTEG */
-		for (i = 0; i < 8; i++) {
-			if (!phte[base + i].v) {
-				found = true;
-				break;
-			}
-		}
-	}
-	
-	if (!found) {
-		/* Secondary hash (not) */
-		uint32_t base2 = (~hash & 0x3ff) << 3;
-		
-		/* Find colliding PTE in PTEG */
-		for (i = 0; i < 8; i++) {
-			if ((phte[base2 + i].v)
-			    && (phte[base2 + i].vsid == vsid)
-			    && (phte[base2 + i].api == api)
-			    && (phte[base2 + i].h == 1)) {
-				found = true;
-				base = base2;
-				h = 1;
-				break;
-			}
-		}
-		
-		if (!found) {
-			/* Find unused PTE in PTEG */
-			for (i = 0; i < 8; i++) {
-				if (!phte[base2 + i].v) {
-					found = true;
-					base = base2;
-					h = 1;
-					break;
-				}
-			}
-		}
-		
-		if (!found)
-			i = RANDI(seed) % 8;
-	}
-	
-	phte[base + i].v = 1;
-	phte[base + i].vsid = vsid;
-	phte[base + i].h = h;
-	phte[base + i].api = api;
-	phte[base + i].rpn = pte->pfn;
-	phte[base + i].r = 0;
-	phte[base + i].c = 0;
-	phte[base + i].wimg = (pte->page_cache_disable ? WIMG_NO_CACHE : 0);
-	phte[base + i].pp = 2; // FIXME
-}
-
-/** Process Instruction/Data Storage Exception
- *
- * @param n      Exception vector number.
- * @param istate Interrupted register context.
- *
- */
-void pht_refill(unsigned int n, istate_t *istate)
-{
-	as_t *as = (AS == NULL) ? AS_KERNEL : AS;
-	uintptr_t badvaddr;
-	
-	if (n == VECTOR_DATA_STORAGE)
-		badvaddr = istate->dar;
-	else
-		badvaddr = istate->pc;
-	
-	page_table_lock(as, true);
-	
-	int pfrc;
-	pte_t *pte = find_mapping_and_check(as, badvaddr,
-	    PF_ACCESS_READ /* FIXME */, istate, &pfrc);
-	
-	if (!pte) {
-		switch (pfrc) {
-		case AS_PF_FAULT:
-			goto fail;
-			break;
-		case AS_PF_DEFER:
-			/*
-			 * The page fault came during copy_from_uspace()
-			 * or copy_to_uspace().
-			 */
-			page_table_unlock(as, true);
-			return;
-		default:
-			panic("Unexpected pfrc (%d).", pfrc);
-		}
-	}
-	
-	/* Record access to PTE */
-	pte->accessed = 1;
-	pht_insert(badvaddr, pte);
-	
-	page_table_unlock(as, true);
-	return;
-	
-fail:
-	page_table_unlock(as, true);
-	pht_refill_fail(badvaddr, istate);
-}
-
-/** Process Instruction/Data Storage Exception in Real Mode
- *
- * @param n      Exception vector number.
- * @param istate Interrupted register context.
- *
- */
-bool pht_refill_real(unsigned int n, istate_t *istate)
-{
-	uintptr_t badvaddr;
-	
-	if (n == VECTOR_DATA_STORAGE)
-		badvaddr = istate->dar;
-	else
-		badvaddr = istate->pc;
-	
-	uint32_t physmem = physmem_top();
-	
-	if ((badvaddr < PA2KA(0)) || (badvaddr >= PA2KA(physmem)))
-		return false;
-	
-	uint32_t page = (badvaddr >> 12) & 0xffff;
-	uint32_t api = (badvaddr >> 22) & 0x3f;
-	
-	uint32_t vsid = sr_get(badvaddr);
-	uint32_t sdr1 = sdr1_get();
-	
-	// FIXME: compute size of PHT exactly
-	phte_t *phte_real = (phte_t *) (sdr1 & 0xffff0000);
-	
-	/* Primary hash (xor) */
-	uint32_t h = 0;
-	uint32_t hash = vsid ^ page;
-	uint32_t base = (hash & 0x3ff) << 3;
-	uint32_t i;
-	bool found = false;
-	
-	/* Find colliding PTE in PTEG */
-	for (i = 0; i < 8; i++) {
-		if ((phte_real[base + i].v)
-		    && (phte_real[base + i].vsid == vsid)
-		    && (phte_real[base + i].api == api)
-		    && (phte_real[base + i].h == 0)) {
-			found = true;
-			break;
-		}
-	}
-	
-	if (!found) {
-		/* Find unused PTE in PTEG */
-		for (i = 0; i < 8; i++) {
-			if (!phte_real[base + i].v) {
-				found = true;
-				break;
-			}
-		}
-	}
-	
-	if (!found) {
-		/* Secondary hash (not) */
-		uint32_t base2 = (~hash & 0x3ff) << 3;
-		
-		/* Find colliding PTE in PTEG */
-		for (i = 0; i < 8; i++) {
-			if ((phte_real[base2 + i].v)
-			    && (phte_real[base2 + i].vsid == vsid)
-			    && (phte_real[base2 + i].api == api)
-			    && (phte_real[base2 + i].h == 1)) {
-				found = true;
-				base = base2;
-				h = 1;
-				break;
-			}
-		}
-		
-		if (!found) {
-			/* Find unused PTE in PTEG */
-			for (i = 0; i < 8; i++) {
-				if (!phte_real[base2 + i].v) {
-					found = true;
-					base = base2;
-					h = 1;
-					break;
-				}
-			}
-		}
-		
-		if (!found) {
-			/* Use secondary hash to avoid collisions
-			   with usual PHT refill handler. */
-			i = RANDI(seed_real) % 8;
-			base = base2;
-			h = 1;
-		}
-	}
-	
-	phte_real[base + i].v = 1;
-	phte_real[base + i].vsid = vsid;
-	phte_real[base + i].h = h;
-	phte_real[base + i].api = api;
-	phte_real[base + i].rpn = KA2PA(badvaddr) >> 12;
-	phte_real[base + i].r = 0;
-	phte_real[base + i].c = 0;
-	phte_real[base + i].wimg = 0;
-	phte_real[base + i].pp = 2; // FIXME
-	
-	return true;
-}
-
-/** Process ITLB/DTLB Miss Exception in Real Mode
- *
- *
- */
-void tlb_refill_real(unsigned int n, uint32_t tlbmiss, ptehi_t ptehi,
-    ptelo_t ptelo, istate_t *istate)
-{
 	uint32_t badvaddr = tlbmiss & 0xfffffffc;
 	uint32_t physmem = physmem_top();
@@ -395,19 +81,19 @@
 void tlb_invalidate_all(void)
 {
-	uint32_t index;
+	asm volatile (
+		"sync\n"
+	);
+	
+	for (unsigned int i = 0; i < 0x00040000; i += 0x00001000) {
+		asm volatile (
+			"tlbie %[i]\n"
+			:: [i] "r" (i)
+		);
+	}
 	
 	asm volatile (
-		"li %[index], 0\n"
-		"sync\n"
-		
-		".rept 64\n"
-		"	tlbie %[index]\n"
-		"	addi %[index], %[index], 0x1000\n"
-		".endr\n"
-		
 		"eieio\n"
 		"tlbsync\n"
 		"sync\n"
-		: [index] "=r" (index)
 	);
 }
@@ -415,16 +101,4 @@
 void tlb_invalidate_asid(asid_t asid)
 {
-	uint32_t sdr1 = sdr1_get();
-	
-	// FIXME: compute size of PHT exactly
-	phte_t *phte = (phte_t *) PA2KA(sdr1 & 0xffff0000);
-	
-	size_t i;
-	for (i = 0; i < 8192; i++) {
-		if ((phte[i].v) && (phte[i].vsid >= (asid << 4)) &&
-		    (phte[i].vsid < ((asid << 4) + 16)))
-			phte[i].v = 0;
-	}
-	
 	tlb_invalidate_all();
 }
@@ -432,5 +106,4 @@
 void tlb_invalidate_pages(asid_t asid, uintptr_t page, size_t cnt)
 {
-	// TODO
 	tlb_invalidate_all();
 }
Index: kernel/arch/ppc32/src/ppc32.c
===================================================================
--- kernel/arch/ppc32/src/ppc32.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/src/ppc32.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -41,10 +41,10 @@
 #include <interrupt.h>
 #include <genarch/fb/fb.h>
-#include <genarch/fb/visuals.h>
+#include <abi/fb/visuals.h>
 #include <genarch/ofw/ofw_tree.h>
 #include <genarch/ofw/pci.h>
 #include <userspace.h>
 #include <mm/page.h>
-#include <proc/uarg.h>
+#include <abi/proc/uarg.h>
 #include <console/console.h>
 #include <sysinfo/sysinfo.h>
@@ -265,6 +265,5 @@
 {
 	userspace_asm((uintptr_t) kernel_uarg->uspace_uarg,
-	    (uintptr_t) kernel_uarg->uspace_stack +
-	    THREAD_STACK_SIZE - SP_DELTA,
+	    (uintptr_t) kernel_uarg->uspace_stack + STACK_SIZE - SP_DELTA,
 	    (uintptr_t) kernel_uarg->uspace_entry);
 	
Index: kernel/arch/ppc32/src/proc/scheduler.c
===================================================================
--- kernel/arch/ppc32/src/proc/scheduler.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ppc32/src/proc/scheduler.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -55,5 +55,5 @@
 	asm volatile (
 		"mtsprg0 %[ksp]\n"
-		:: [ksp] "r" (KA2PA(&THREAD->kstack[THREAD_STACK_SIZE - SP_DELTA]))
+		:: [ksp] "r" (KA2PA(&THREAD->kstack[STACK_SIZE - SP_DELTA]))
 	);
 }
Index: kernel/arch/sparc64/Makefile.inc
===================================================================
--- kernel/arch/sparc64/Makefile.inc	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/Makefile.inc	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -31,5 +31,5 @@
 BFD = binary
 
-GCC_CFLAGS += -m64 -mcpu=ultrasparc -mcmodel=medlow
+GCC_CFLAGS += -m64 -mcpu=ultrasparc -mcmodel=medlow -mno-fpu
 SUNCC_CFLAGS += -m64 -xarch=sparc -xregs=appl,no%float
 
@@ -84,7 +84,5 @@
 	arch/$(KARCH)/src/drivers/tick.c \
 	arch/$(KARCH)/src/drivers/kbd.c \
-	arch/$(KARCH)/src/drivers/sgcn.c \
 	arch/$(KARCH)/src/drivers/pci.c \
-	arch/$(KARCH)/src/drivers/fhc.c \
 	arch/$(KARCH)/src/trap/$(USARCH)/interrupt.c
 
Index: kernel/arch/sparc64/_link.ld.in
===================================================================
--- kernel/arch/sparc64/_link.ld.in	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/_link.ld.in	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -15,11 +15,10 @@
 		ktext_start = .;
 		*(K_TEXT_START)
-		*(.text);
+		*(.text .text.*);
 		ktext_end = .;
 		
 		kdata_start = .;
 		*(K_DATA_START)
-		*(.rodata);
-		*(.rodata.*);
+		*(.rodata .rodata.*);
 		*(.data);                   /* initialized data */
 		*(.sdata);
Index: kernel/arch/sparc64/include/barrier.h
===================================================================
--- kernel/arch/sparc64/include/barrier.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/include/barrier.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,14 +37,4 @@
 
 #include <trace.h>
-
-#ifdef KERNEL
-
-#include <typedefs.h>
-
-#else
-
-#include <stdint.h>
-
-#endif
 
 /*
Index: kernel/arch/sparc64/include/cpu.h
===================================================================
--- kernel/arch/sparc64/include/cpu.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/include/cpu.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -59,9 +59,4 @@
 #include <arch/asm.h>
 
-#ifdef CONFIG_SMP
-#include <arch/mm/cache.h>
-#endif
-
-
 #if defined (SUN4U)
 #include <arch/sun4u/cpu.h>
Index: kernel/arch/sparc64/include/istate.h
===================================================================
--- kernel/arch/sparc64/include/istate.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/include/istate.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,13 +37,15 @@
 #define KERN_sparc64_ISTATE_H_
 
+#include <trace.h>
+
+#ifdef KERNEL
+
 #include <arch/regdef.h>
 
-#ifdef KERNEL
-#include <typedefs.h>
-#include <trace.h>
-#else
-#include <sys/types.h>
-#define NO_TRACE
-#endif
+#else /* KERNEL */
+
+#include <libarch/regdef.h>
+
+#endif /* KERNEL */
 
 typedef struct istate {
Index: kernel/arch/sparc64/include/mm/page.h
===================================================================
--- kernel/arch/sparc64/include/mm/page.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/include/mm/page.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -54,6 +54,4 @@
 #define MMU_PAGES_PER_PAGE	(1 << (PAGE_WIDTH - MMU_PAGE_WIDTH))
 
-#ifdef KERNEL
-
 #ifndef __ASM__
 
@@ -77,6 +75,4 @@
 #endif /* !def __ASM__ */
 
-#endif /* KERNEL */
-
 #endif
 
Index: kernel/arch/sparc64/include/mm/sun4u/as.h
===================================================================
--- kernel/arch/sparc64/include/mm/sun4u/as.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/include/mm/sun4u/as.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup sparc64mm	
+/** @addtogroup sparc64mm
  * @{
  */
@@ -38,12 +38,10 @@
 #include <arch/mm/tte.h>
 
-#define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH	1
+#define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  1
 
-#define KERNEL_ADDRESS_SPACE_START_ARCH		(unsigned long) 0x0000000000000000
-#define KERNEL_ADDRESS_SPACE_END_ARCH		(unsigned long) 0xffffffffffffffff
-#define USER_ADDRESS_SPACE_START_ARCH		(unsigned long) 0x0000000000000000
-#define USER_ADDRESS_SPACE_END_ARCH		(unsigned long) 0xffffffffffffffff
-
-#define USTACK_ADDRESS_ARCH	(0xffffffffffffffffULL - (PAGE_SIZE - 1))
+#define KERNEL_ADDRESS_SPACE_START_ARCH  UINT64_C(0x0000000000000000)
+#define KERNEL_ADDRESS_SPACE_END_ARCH    UINT64_C(0xffffffffffffffff)
+#define USER_ADDRESS_SPACE_START_ARCH    UINT64_C(0x0000000000000000)
+#define USER_ADDRESS_SPACE_END_ARCH      UINT64_C(0xffffffffffffffff)
 
 #ifdef CONFIG_TSB
Index: kernel/arch/sparc64/include/mm/sun4u/frame.h
===================================================================
--- kernel/arch/sparc64/include/mm/sun4u/frame.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/include/mm/sun4u/frame.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -52,5 +52,4 @@
 #define FRAME_SIZE		(1 << FRAME_WIDTH)
 
-#ifdef KERNEL
 #ifndef __ASM__
 
@@ -80,5 +79,4 @@
 
 #endif
-#endif
 
 #endif
Index: kernel/arch/sparc64/include/mm/sun4v/as.h
===================================================================
--- kernel/arch/sparc64/include/mm/sun4v/as.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/include/mm/sun4v/as.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -40,12 +40,10 @@
 #include <arch/mm/tsb.h>
 
-#define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH	1
+#define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  1
 
-#define KERNEL_ADDRESS_SPACE_START_ARCH		(unsigned long) 0x0000000000000000
-#define KERNEL_ADDRESS_SPACE_END_ARCH		(unsigned long) 0xffffffffffffffff
-#define USER_ADDRESS_SPACE_START_ARCH		(unsigned long) 0x0000000000000000
-#define USER_ADDRESS_SPACE_END_ARCH		(unsigned long) 0xffffffffffffffff
-
-#define USTACK_ADDRESS_ARCH	(0xffffffffffffffffULL - (PAGE_SIZE - 1))
+#define KERNEL_ADDRESS_SPACE_START_ARCH  UINT64_C(0x0000000000000000)
+#define KERNEL_ADDRESS_SPACE_END_ARCH    UINT64_C(0xffffffffffffffff)
+#define USER_ADDRESS_SPACE_START_ARCH    UINT64_C(0x0000000000000000)
+#define USER_ADDRESS_SPACE_END_ARCH      UINT64_C(0xffffffffffffffff)
 
 #ifdef CONFIG_TSB
Index: kernel/arch/sparc64/include/mm/sun4v/frame.h
===================================================================
--- kernel/arch/sparc64/include/mm/sun4v/frame.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/include/mm/sun4v/frame.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -42,5 +42,4 @@
 #define FRAME_SIZE		(1 << FRAME_WIDTH)
 
-#ifdef KERNEL
 #ifndef __ASM__
 
@@ -52,5 +51,4 @@
 
 #endif
-#endif
 
 #endif
Index: kernel/arch/sparc64/include/mm/sun4v/page.h
===================================================================
--- kernel/arch/sparc64/include/mm/sun4v/page.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/include/mm/sun4v/page.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -46,6 +46,4 @@
 #define MMU_PAGES_PER_PAGE	(1 << (PAGE_WIDTH - MMU_PAGE_WIDTH))
 
-#ifdef KERNEL
-
 #ifndef __ASM__
 
@@ -69,6 +67,4 @@
 #endif /* !def __ASM__ */
 
-#endif /* KERNEL */
-
 #endif
 
Index: kernel/arch/sparc64/include/sun4u/cpu.h
===================================================================
--- kernel/arch/sparc64/include/sun4u/cpu.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/include/sun4u/cpu.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -60,8 +60,4 @@
 #include <trace.h>
 
-#ifdef CONFIG_SMP
-#include <arch/mm/cache.h>
-#endif
-
 typedef struct {
 	uint32_t mid;              /**< Processor ID as read from
Index: kernel/arch/sparc64/include/sun4v/regdef.h
===================================================================
--- kernel/arch/sparc64/include/sun4v/regdef.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/include/sun4v/regdef.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup sparc64	
+/** @addtogroup sparc64
  * @{
  */
@@ -37,17 +37,8 @@
 #define KERN_sparc64_sun4v_REGDEF_H_
 
-#define PSTATE_IE_BIT	(1 << 1)
-#define PSTATE_PRIV_BIT	(1 << 2)
-#define PSTATE_PEF_BIT	(1 << 4)
+#define TSTATE_CWP_MASK  0x1f
 
-#define TSTATE_PSTATE_SHIFT	8
-#define TSTATE_PRIV_BIT		(PSTATE_PRIV_BIT << TSTATE_PSTATE_SHIFT)
-#define TSTATE_CWP_MASK		0x1f
-#define TSTATE_IE_BIT		(PSTATE_IE_BIT << TSTATE_PSTATE_SHIFT)
-
-#define WSTATE_NORMAL(n)	(n)
-#define WSTATE_OTHER(n)		((n) << 3)
-
-#define TSTATE_PEF_BIT		(PSTATE_PEF_BIT << TSTATE_PSTATE_SHIFT)
+#define WSTATE_NORMAL(n)  (n)
+#define WSTATE_OTHER(n)   ((n) << 3)
 
 #endif
Index: kernel/arch/sparc64/include/types.h
===================================================================
--- kernel/arch/sparc64/include/types.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/include/types.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,4 +37,5 @@
 
 typedef uint64_t size_t;
+typedef int64_t ssize_t;
 
 typedef uint64_t uintptr_t;
Index: kernel/arch/sparc64/src/console.c
===================================================================
--- kernel/arch/sparc64/src/console.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/src/console.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -38,5 +38,4 @@
 #include <arch/drivers/scr.h>
 #include <arch/drivers/kbd.h>
-#include <arch/drivers/sgcn.h>
 #include <genarch/srln/srln.h>
 #include <console/chardev.h>
@@ -89,26 +88,4 @@
 }
 
-/** Initilize I/O on the Serengeti machine. */
-static void serengeti_init(void)
-{
-#ifdef CONFIG_SGCN_KBD
-	sgcn_instance_t *sgcn_instance = sgcnin_init();
-	if (sgcn_instance) {
-		srln_instance_t *srln_instance = srln_init();
-		if (srln_instance) {
-			indev_t *sink = stdin_wire();
-			indev_t *srln = srln_wire(srln_instance, sink);
-			sgcnin_wire(sgcn_instance, srln);
-		}
-	}
-#endif
-	
-#ifdef CONFIG_SGCN_PRN
-	outdev_t *sgcndev = sgcnout_init();
-	if (sgcndev)
-		stdout_wire(sgcndev);
-#endif
-}
-
 /**
  * Initialize input/output. Auto-detects the type of machine
@@ -127,9 +104,6 @@
 	prop = ofw_tree_getprop(aliases, "def-cn");
 	
-	if ((!prop) || (!prop->value) || (str_cmp(prop->value, "/sgcn") != 0)) {
+	if ((!prop) || (!prop->value))
 		standard_console_init(aliases);
-	} else {
-		serengeti_init();
-	}
 }
 
Index: kernel/arch/sparc64/src/drivers/kbd.c
===================================================================
--- kernel/arch/sparc64/src/drivers/kbd.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/sparc64/src/drivers/kbd.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -35,5 +35,4 @@
 #include <arch/drivers/kbd.h>
 #include <genarch/ofw/ofw_tree.h>
-#include <genarch/ofw/fhc.h>
 #include <genarch/ofw/ebus.h>
 #include <console/console.h>
@@ -51,8 +50,4 @@
 #endif
 
-#ifdef CONFIG_Z8530
-#include <genarch/drivers/z8530/z8530.h>
-#endif
-
 #ifdef CONFIG_NS16550
 #include <genarch/drivers/ns16550/ns16550.h>
@@ -60,90 +55,4 @@
 
 #ifdef CONFIG_SUN_KBD
-
-#ifdef CONFIG_Z8530
-
-static bool kbd_z8530_init(ofw_tree_node_t *node)
-{
-	const char *name = ofw_tree_node_name(node);
-	
-	if (str_cmp(name, "zs") != 0)
-		return false;
-	
-	/*
-	 * Read 'interrupts' property.
-	 */
-	ofw_tree_property_t *prop = ofw_tree_getprop(node, "interrupts");
-	if ((!prop) || (!prop->value)) {
-		printf("z8530: Unable to find interrupts property\n");
-		return false;
-	}
-	
-	uint32_t interrupts = *((uint32_t *) prop->value);
-	
-	/*
-	 * Read 'reg' property.
-	 */
-	prop = ofw_tree_getprop(node, "reg");
-	if ((!prop) || (!prop->value)) {
-		printf("z8530: Unable to find reg property\n");
-		return false;
-	}
-	
-	size_t size = ((ofw_fhc_reg_t *) prop->value)->size;
-	
-	uintptr_t pa;
-	if (!ofw_fhc_apply_ranges(node->parent,
-	    ((ofw_fhc_reg_t *) prop->value), &pa)) {
-		printf("z8530: Failed to determine address\n");
-		return false;
-	}
-	
-	inr_t inr;
-	cir_t cir;
-	void *cir_arg;
-	if (!ofw_fhc_map_interrupt(node->parent,
-	    ((ofw_fhc_reg_t *) prop->value), interrupts, &inr, &cir,
-	    &cir_arg)) {
-		printf("z8530: Failed to determine interrupt\n");
-		return false;
-	}
-	
-	/*
-	 * We need to pass aligned address to hw_map().
-	 * However, the physical keyboard address can
-	 * be pretty much unaligned, depending on the
-	 * underlying controller.
-	 */
-	uintptr_t aligned_addr = ALIGN_DOWN(pa, PAGE_SIZE);
-	size_t offset = pa - aligned_addr;
-	
-	z8530_t *z8530 = (z8530_t *)
-	    (hw_map(aligned_addr, offset + size) + offset);
-	
-	z8530_instance_t *z8530_instance = z8530_init(z8530, inr, cir, cir_arg);
-	if (z8530_instance) {
-		kbrd_instance_t *kbrd_instance = kbrd_init();
-		if (kbrd_instance) {
-			indev_t *sink = stdin_wire();
-			indev_t *kbrd = kbrd_wire(kbrd_instance, sink);
-			z8530_wire(z8530_instance, kbrd);
-		}
-	}
-	
-	/*
-	 * This is the necessary evil until the userspace drivers are
-	 * entirely self-sufficient.
-	 */
-	sysinfo_set_item_val("kbd", NULL, true);
-	sysinfo_set_item_val("kbd.inr", NULL, inr);
-	sysinfo_set_item_val("kbd.address.kernel", NULL,
-	    (uintptr_t) z8530);
-	sysinfo_set_item_val("kbd.address.physical", NULL, pa);
-	sysinfo_set_item_val("kbd.type.z8530", NULL, true);
-	
-	return true;
-}
-
-#endif /* CONFIG_Z8530 */
 
 #ifdef CONFIG_NS16550
@@ -243,8 +152,4 @@
 void kbd_init(ofw_tree_node_t *node)
 {
-#ifdef CONFIG_Z8530
-	kbd_z8530_init(node);
-#endif
-	
 #ifdef CONFIG_NS16550
 	kbd_ns16550_init(node);
